import React from 'react';
import PropTypes from 'prop-types';

import './Collapse.css';
class Collapse extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: this.props.isOpen
    };
  }

  toggleCollapse() {
    this.setState({isOpen: !this.state.isOpen});
  }

  render() {
    return (
			<div className="list-group-item collapse">
				<div className="collapse-handle" onClick={this.toggleCollapse.bind(this)}>
					{this.props.title}
					<i className="material-icons pull-right">{this.props.icon}</i>
				</div>
				<div className={`${this.state.isOpen ? '' : 'hidden'} collapse-body`}>
					{this.props.children}
				</div>
			</div>
    );
  }

}

Collapse.propTypes = {
  title: PropTypes.string.isRequired,
  icon: PropTypes.string.isRequired,
  isOpen: PropTypes.bool
};

export default Collapse;
