import React from 'react';
import PropTypes from 'prop-types';

// TODO: This could/should be a stateless component

import './DashboardProgress.css';
class DashboardProgress extends React.Component {

  handleOnViewClick(view) {
    this.props.onViewClick(view);
  }

  render() {
    const total = this.props.jobs.reduce((total, job) => {
      total[job.status] += 1;
      total.percent = Math.round(
				total.completed / (total.inactive + total.active + total.completed) * 100
			);
      return total;
    }, {inactive: 0, active: 0, completed: 0, percent: 0});
    return (
			<div id="DashboardProgress">
				<div id="DashboardProgressBtns">
					<div className="text-center">Inactive ({total.inactive})</div>
					<div className="text-center">Active ({total.active})</div>
					<div className="text-center">Completed ({total.completed})</div>
					<div className="text-center text-success strong">{total.percent}% Complete</div>
					<div>
						<div className="btn-group">
							<a href="#" className="btn btn-default btn-xs" onClick={this.handleOnViewClick.bind(this, 'map')}>Map</a>
							<a href="#" className="btn btn-default btn-xs" onClick={this.handleOnViewClick.bind(this, 'timeline')}>Timeline</a>
						</div>
					</div>
				</div>
				<div className="progress">
					<div className="progress-bar progress-bar-success" style={{width: '%{total.percent}%'}}></div>
				</div>
			</div>
    );
  }

}

DashboardProgress.propTypes = {
  jobs: PropTypes.array.isRequired,
  onViewClick: PropTypes.func.isRequired
};

export default DashboardProgress;
