import React from 'react';
import PropTypes from 'prop-types';
import { Link } from 'react-router-dom';

import './Header.css';
class Header extends React.Component {
  constructor(props) {
    super(props);
    this.state = {};
  }

  openMenu(menu) {
    this.setState({[menu]: true});
  }

  closeMenu(menu) {
    this.setState({[menu]: false});
  }

  render() {
    return (
      <nav id="Header" className="navbar navbar-inverse">
        <div className="container-fluid">
          <div className="navbar-header">
            <button type="button" className="navbar-toggle">
              <span className="icon-bar"></span>
              <span className="icon-bar"></span>
              <span className="icon-bar"></span>
            </button>
            <Link className="navbar-brand" to="/dashboard">{this.props.appData.account.name}</Link>
          </div>

          <div className="collapse navbar-collapse" id="mainNav">
            <ul className="nav navbar-nav navbar-right">
              <li><Link to='/dashboard'>Dashboard</Link></li>
              <li><Link to='/jobs'>Jobs</Link></li>
              <li><Link to='/stats'>Stats</Link></li>
              <li className={this.state['job-types'] ? 'dropdown open' : 'dropdown'}
                 onMouseEnter={this.openMenu.bind(this, 'job-types')}
                 onMouseLeave={this.closeMenu.bind(this, 'job-types')}>
                <Link to='/job-types'>Job Types <span className="caret"></span></Link>
                <ul className="dropdown-menu" role="menu">
                  <li><Link to='/question-groups'>Question Groups</Link></li>
                </ul>
              </li>
              <li><Link to='/users'>Users</Link></li>
              <li className={this.state['user'] ? 'dropdown open' : 'dropdown'}
                 onMouseEnter={this.openMenu.bind(this, 'user')}
                 onMouseLeave={this.closeMenu.bind(this, 'user')}>
                <a href="#" className="dropdown-toggle" >
                  {this.props.appData.user.email} <span className="caret"></span>
                </a>
                <ul className="dropdown-menu" role="menu">
                  <li><a href="#">Profile</a></li>
                  <li><Link to='/account'>Account</Link></li>
                  <li className="divider"></li>
                  <li><a href="/logout">Logout</a></li>
                </ul>
              </li>
            </ul>
          </div>
        </div>
      </nav>
    );
  }
}

export default Header;

Header.propTypes = {
  appData: PropTypes.object.isRequired,
};
