import React from 'react';
import PropTypes from 'prop-types';

import './NavSidebar.css';
class NavSidebar extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      active: props.navItems[0].id
    };
  }

  handleOnClick(tabId) {
    this.setState({active: tabId});
    this.props.onClick(tabId);
  }

  render() {
    const navItems = this.props.navItems.map((item, index) => (
			<li
				className={`nav nav-sidebar-item ${this.state.active === item.id ? 'active' : ''}`}
				key={index}
				onClick={this.handleOnClick.bind(this, item.id)}
			>
				{item.title}
			</li>
		));
    return (
			<div className="nav-sidebar">
				<ul className="nav nav-sidebar-list">
					{navItems}
				</ul>
				{this.props.children}
			</div>
    );
  }

}

NavSidebar.propTypes = {
  navItems: PropTypes.array.isRequired,
  onClick: PropTypes.func.isRequired
};

export default NavSidebar;
