import React from 'react';
import PropTypes from 'prop-types';

// TODO: This could/should be a stateless component

import './StageProgress.css';
class StageProgress extends React.Component {

  render() {
    const job = this.props.job;
    const ProgressBars = job.stages.map((stage, i) => {
      let progressClass = '';
      if (job.currentStageId > i) {
        progressClass = 'progress-bar-complete';
      } else if (job.currentStageId < i) {
        progressClass = 'progress-bar-incomplete';
      }

      return (
				<div className={`progress-bar ${progressClass}`}
						 style={{width: `${(stage.original_estimate / this.props.job.original_estimate) * 99.5}%`}}
						 key={i}>
				</div>
      );
    });
    return (
			<div className="stage-progress">
				<div className="progress progress-striped active">
					{ProgressBars}
				</div>
			</div>
    );
  }

}

StageProgress.propTypes = {
  job: PropTypes.object.isRequired,
};

export default StageProgress;
