import React from 'react';
import PropTypes from 'prop-types';
import { Input } from '6thman-shared';
import Collapse from '../Collapse/Collapse.jsx';

import './StageTemplateList.css';
class StageTemplateList extends React.Component {
  constructor(props) {
    super(props);
    this.icons = {
      StageMilestone: 'list',
      StageTravel: 'navigation',
      StageWork: 'slow_motion_video',
    };
  }

  handleEditStage(i, inputData) {
    this.props.onChange(i, inputData);
  }

  render() {
    const Stages = this.props.stages.map((stage, i) => {
      let icon = this.icons[stage.content_template_model];
      const TitleInput = <div className="row">
													 <div className="col-xs-12">
														 <Input
															 name="title"
															 label="Title"
															 value={stage.title}
															 onChange={this.handleEditStage.bind(this, i)}/>
													 </div>
												 </div>;
      let Inputs;
      if (stage.content_template_model === 'StageTravel') {
        Inputs = <div>
									 <div className="row">
										 <div className="col-xs-12">
											 <Input
												 name="origin_location"
												 label="Origin"
												 value={stage.origin_location}
												 onChange={this.handleEditStage.bind(this, i)}
											 />
										 </div>
									 </div>
									 <div className="row">
										 <div className="col-xs-12 last-input">
											 <Input
												 name="destination_location"
												 label="Destination"
												 value={stage.destination_location}
												 onChange={this.handleEditStage.bind(this, i)}
											 />
										 </div>
									 </div>
								 </div>;
      } else if (stage.content_template_model === 'StageWork') {
        Inputs = <div className="row">
									 <div className="col-xs-12">
										 <Input
											 name="original_estimate"
											 label="Original Estimate"
											 value={stage.original_estimate}
											 onChange={this.handleEditStage.bind(this, i)}
										 />
									 </div>
									 <div className="col-xs-12 last-input">
										 <Input
											 name="location"
											 label="Location"
											 value={stage.location}
											 onChange={this.handleEditStage.bind(this, i)}
										 />
									 </div>
								 </div>;
      } else {
        Inputs = <div>
									 <div className="row">
										 <div className="col-xs-12">
											 <Input
												 name="original_estimate"
												 label="Original Estimate"
												 value={stage.original_estimate}
												 onChange={this.handleEditStage.bind(this, i)}
											 />
										 </div>
									 </div>
									 <div className="row">
										 <div className="col-xs-12 last-input">
											 <Input
												 label="Questions"
												 type="select"
												 name="question_group_id"
												 value={stage.question_group_id}
												 onChange={this.handleEditStage.bind(this, i)}
												 options={this.props.questions}
											 />
										 </div>
									 </div>
								 </div>;
      }
      return (
				<Collapse title={stage.title} icon={icon} key={i} isOpen={true}>
					{TitleInput}
					{Inputs}
				</Collapse>
      );
    });
    return (
			<div className="list-group stage-template-list">
				{Stages}
			</div>
    );
  }

}

StageTemplateList.propTypes = {
  stages: PropTypes.array.isRequired,
  onChange: PropTypes.func.isRequired,
  questions: PropTypes.array.isRequired
};

export default StageTemplateList;
