import React from 'react';
import redrover from 'redrover';
import herald from 'herald';
import { immUtils, Input, PanelHeader } from '6thman-shared';

// TODO: The account ID and `isEditing: true` are currently hardcoded to true bc only one account

import './Account.css';
class Account extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      account: {
        name: '',
        email: '',
        phone: '',
        address_1:'',
        address_2: '',
        city: '',
        state: '',
        zip: ''
      }
    };
    this.isEditing = true;
    this.Account = redrover('/api/account');
  }

  componentDidMount() {
    this.Account.get().then((response) => {
      console.log(response);
      this.setState({account: response});
    }).catch((err) => {
      herald.error(err, 'Error');
    });
  }

  handleChange(inputDate) {
    let account = immUtils.copyObj(this.state.account);
    account[inputDate.name] = inputDate.value;
    this.setState({account: account});
  }

  handleSubmit(event) {
    event.preventDefault();
    const method = this.isEditing ? 'put' : 'post';
    this.Account[method](this.state.account).then((response) => {
      herald.success('Account Updated!', 'Success');
    }).catch((err) => {
      herald.error(err, 'Error');
    });
  }

  render() {
    return (
      <div id="Account">
        <div className="col-sm-4 col-sm-offset-4">
          <div className="panel panel-default">
            <div className="panel-body">
              <PanelHeader title="Account Details"/>
              <form onSubmit={this.handleSubmit.bind(this)}>
            		<div className="row">
               		<div className="col-sm-12">
										<Input
											label="Company Name"
											name="name"
											value={this.state.account.name}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-6">
										<Input
											label="Phone Number"
											name="phone"
											value={this.state.account.phone}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
                	<div className="col-sm-6">
                		<Input
											label="Email"
											name="email"
											value={this.state.account.email}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
                {/*
                <div className="row">
									<div className="col-sm-12">
										<Input
											label="Address 1"
											name="address_1"
											value={this.state.account.address_1}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-12">
										<Input
											label="Address 2"
											name="address_2"
											value={this.state.account.address_2}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
								  <div className="col-sm-6">
										<Input
											label="City"
											name="city"
											value={this.state.account.city}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											label="State"
											name="state"
											value={this.state.account.state}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
                <div className="row">
                	<div className="col-sm-4">
										<Input
											label="Zip Code"
											name="zip_code"
											value={this.state.account.zip}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								*/}
                <div className="row">
                  <div className="col-sm-12 text-right">
                    <button className="btn btn-success" type="submit">Save</button>
                  </div>
                </div>
              </form>
            </div>
          </div>
        </div>
			</div>
    );
  }
};

export default Account;
