/* eslint-disable */
/* 
	Eslint is disabled for this whole file because of the way we escape ${short_codes}
	for display
	-- Unexpected template string expression  no-template-curly-in-string
*/

import React from 'react';
import redrover from 'redrover';
import herald from 'herald';
import { immUtils, Input, PanelDivider, LoadingIndicator } from '6thman-shared';
import { Redirect } from 'react-router-dom';
import StageTemplateList from '../../components/StageTemplateList/StageTemplateList.jsx';

import './JobType.css';
class JobType extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      job_type: {
        title: '',
				ref_id: '',
				template: {
					ref_id:'',
					address: {
						address_1: '',
						address_2: '',
						city: '',
						state:'',
						zip: ''
					},
					customer: {
						first_name: '',
						last_name: '',
						phone: '',
						email: ''
					},
					scheduled_time: '',
					user_id: '',
					crew: '',
					description: '',
					stages:[]
      	}
			},
			isLoading: true,
			redirect: false,
    };
		this.isEditing = props.match.params.id ? true : false;
    this.JobType = redrover(`/api${props.match.url}`);
		this.QuestionGroups = redrover(`/api/question-groups`);
  }

  componentDidMount() {
		this.QuestionGroups.get().then((questionGroups) => {
			this.questionOptions = questionGroups.map((questionGroup) => {
				return {name: questionGroup.title, value: questionGroup._id};
			});
			// If there is an id param, get the type to edit
			if (this.isEditing) {
				this.JobType.get().then((response) => {
					this.setState({
						job_type: response,
						isLoading: false
					});
				}).catch((err) => {
					herald.error(err, 'Error');
				});
			} else {
				this.setState({isLoading: false});
			}
		}).catch((err) => {

		});
  }

  handleChange(inputData) {
    let job_type = immUtils.copyObj(this.state.job_type);
		const updatedJobType = immUtils.update(job_type, inputData.name, inputData.value);
    this.setState({job_type: updatedJobType});
  }

  handleSubmit(event) {
    event.preventDefault();
		console.log('Stages: ', JSON.stringify(this.state.job_type.template.stages));
    const method = this.isEditing ? 'put' : 'post';
		console.log('JobType: ', this.state.job_type);
    this.JobType[method](this.state.job_type).then((response) => {
			console.log('RESPONSE: ', response);
			const title = `"${response.title}"`;
			const msg = this.isEditing ? `${title} Updated!` : `${title} Created!`;
			herald.success(msg, 'Success');
			if (!this.isEditing) {
				this.setState({redirect: `/job-type/${response._id}`});
			}
    }).catch((err) => {
			const validationErr = err.errors;
			const bestErr = validationErr[Object.keys(validationErr)[0]].message || err.message;
      herald.error(bestErr, 'Error');
    });
  }

  handleDelete(event) {
    this.JobType.delete().then((response) => {
      this.setState({redirect: '/job-types'});
			herald.success('Deleted!', 'Success');
    }).catch((err) => {
      herald.error(err, 'Error');
    });
  }

	handleAddStage(content_template_model) {
		console.log('adding: ', content_template_model);
		let job_type = immUtils.copyObj(this.state.job_type);
		let stages = job_type.template.stages;
		let stage = {};
		stage.content_template_model = content_template_model;
		if (content_template_model === 'StageTravel') {
			stage.title = 'Travel';
		} else if (content_template_model === 'StageWork') {
			stage.title = 'Work';
		} else {
			stage.title = 'Milestone';
			stage.question_group_id = this.questionOptions[0].value; // set default for select element
		}
		stages.push(stage);
		job_type.template.stages = stages;
		console.log(job_type);
		this.setState({
			job_type: job_type,
		});
	}

	handleEditStage(i, inputData) {
//		console.log(i, inputData);
//		console.log(this.state.job_type);
		let job_type = immUtils.copyObj(this.state.job_type);
		let stages = job_type.template.stages;
		console.log(stages[i]);
		stages[i][inputData.name] = inputData.value;
		job_type.stages = stages;
		this.setState({job_type: job_type});
		console.log(this.state.job_type);
	}

  render() {
		if (this.state.redirect) { return (<Redirect to={this.state.redirect} />)}
		if (this.state.isLoading) { return <LoadingIndicator /> }
		return (
			<div id="JobType" className="col-sm-10 col-sm-offset-1">
				<div className="row">
					<div className="col-sm-6">
						<div className="panel panel-default">
							<div className="panel-body">
								<div className="row">
									<div className="col-sm-8">
										<Input
											name="title"
											label="Title"
											value={this.state.job_type.title}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-4">
										<Input
											name="ref_id"
											label="Ref Id"
											value={this.state.job_type.ref_id}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-4">
									</div>
								</div>
								<PanelDivider text="Job Details" />
								<div className="row">
									<div className="col-sm-6">
										<Input
											name="template.ref_id"
											label="Job #"
											value={this.state.job_type.template.ref_id}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											name="template.scheduled_time"
											label="Scheduled Time"
											value={this.state.job_type.template.scheduled_time}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-6">
										<Input
											name="template.user_id"
											label="Assigned User"
											value={this.state.job_type.template.user_id}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											name="template.crew"
											label="Crew"
											value={this.state.job_type.template.crew}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-12">
										<Input
											label="Description"
											name="template.description"
											type="textarea"
											value={this.state.job_type.template.description}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<PanelDivider text="Customer Details" />
								<div className="row">
									<div className="col-sm-6">
										<Input
											name="template.customer.first_name"
											label="First Name"
											value={this.state.job_type.template.customer.first_name}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											name="template.customer.last_name"
											label="Last Name"
											value={this.state.job_type.template.customer.last_name}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-6">
										<Input
											name="template.customer.email"
											label="Email"
											value={this.state.job_type.template.customer.email}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											name="template.customer.phone"
											label="Phone"
											value={this.state.job_type.template.customer.phone}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								{/*
								<PanelDivider text="Address Details" />
								<div className="row">
									<div className="col-sm-6">
										<Input
											label="Address 1"
											name="template.address.address_1"
											value={this.state.job_type.template.address.address_1}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-6">
										<Input
											label="Address 2"
											name="template.address.address_2"
											value={this.state.job_type.template.address.address_2}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
								</div>
								<div className="row">
									<div className="col-sm-4">
										<Input
											label="City"
											name="template.address.city"
											value={this.state.job_type.template.address.city}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-4">
										<Input
											label="State"
											name="template.address.state"
											value={this.state.job_type.template.address.state}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-4">
										<Input
											label="Zip Code"
											name="template.address.zip"
											value={this.state.job_type.template.address.zip}
											onChange={this.handleChange.bind(this)}
										/>
									</div>
									<div className="col-sm-4"></div>
								</div>
								*/}
								<PanelDivider text="Stages" />
								<StageTemplateList
									stages={this.state.job_type.template.stages}
									onChange={this.handleEditStage.bind(this)}
									questions={this.questionOptions}
								/>
								<div className="row">
									<div className="col-sm-6">
										<span className="delete-text" onClick={this.handleDelete.bind(this)}>Delete</span>
									</div>
									<div className="col-sm-6 text-right">
										<button className="btn btn-success" onClick={this.handleSubmit.bind(this)}>Submit</button>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div className="col-sm-6">
						<div className="well">
							<h5>Template Codes</h5>
							<div className="row">
								<div className="col-sm-6">
									<h6>{"${user_id}"}</h6>
									<h6>{"${scheduled_time}"}</h6>
									<h6>{"${origin}"}</h6>
									<h6>{"${crew}"}</h6>
									<h6>{"${customer_first_name}"}</h6>
									<h6>{"${customer_phone}"}</h6>
									<h6>{"${customer_email}"}</h6>
									<h6>{"${customer_last_name}"}</h6>
									<h6>{"${origin_estimate}"}</h6>
									<h6>{"${stop_1}"}</h6>
								</div>
								<div className="col-sm-6">
									<h6>{"${stop_1_estimate}"}</h6>
									<h6>{"${description}"}</h6>
									<h6>{"${stop_1_estimate}"}</h6>
									<h6>{"${stop_2}"}</h6>
									<h6>{"${stop_2_estimate}"}</h6>
									<h6>{"${stop_3}"}</h6>
									<h6>{"${stop_3_estimate}"}</h6>
									<h6>{"${ref_id}"}</h6>
									<h6>{"${destination_estimate}"}</h6>
									<h6>{"${destination}"}</h6>
								</div>
							</div>
						</div>
						<div className="list-group" style={{marginTop: this.state.stagesOffSet}}>
							<a className="list-group-item" onClick={() => {this.handleAddStage('StageTravel')}}>
								Travel
								<i className="material-icons pull-right"></i>
							</a>
							<a className="list-group-item" onClick={() => {this.handleAddStage('StageWork')}}>
								Work
								<i className="material-icons pull-right"></i>
							</a>
							<a className="list-group-item" onClick={() => {this.handleAddStage('StageMilestone')}}>
								Milestone
								<i className="material-icons pull-right"></i>
							</a>
						</div>
					</div>
				</div>
			</div>
		)
  }
};

export default JobType;
